VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private WithEvents hParent  As VB.PictureBox
Attribute hParent.VB_VarHelpID = -1

Private Enum enumButtonFaceState
    BFS_NORMAL_UP = 0
    BFS_NORMAL_DOWN = 1
    BFS_FOCUS_UP = 2
    BFS_FOCUS_DOWN = 3
    BFS_DISABLED = 4
End Enum
Public Enum enumButtonStyles
    [Style SC-0] = 0
    [Style SC-1] = 1
    [Style SC-2] = 2
    [Style SC-3] = 3
    [Style SC-4] = 4
    [Style SC-5] = 5
    [Style SC-6] = 6
    [Style SC-7] = 7
End Enum

Public Event Draw()
Public Event Click()
Public Event DblClick()
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event ButtonFaceRedraw(ByVal State As Integer)
Public Event MissClick()
Public Event ButonResize()
Public Event LeftClick(Shift As Integer)
Public Event RightClick(Shift As Integer)
Public Event MiddleClick(Shift As Integer)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)

'//Property Values
Private m_Caption           As String
Private m_Style             As enumButtonStyles
Private m_State             As enumButtonFaceState


'//Class Variables
Private m_LeftClicked       As Boolean
Private m_Pressed           As Boolean
Private m_HasFocus          As Boolean
Private m_ClickedOver       As Boolean
Private m_BlockDraw         As Boolean

Private Sub Class_Terminate()
    Set hParent = Nothing
End Sub






Public Sub Refresh()
    m_BlockDraw = False
    Call SetState(m_State)
End Sub
Public Sub Move(ByVal lngLeft As Long, _
                ByVal lngTop As Long, _
                ByVal lngWidth As Long, _
                ByVal lngHeight As Long)
    m_BlockDraw = True
    hParent.Move lngLeft, lngTop, lngWidth, lngHeight
    m_BlockDraw = False
    Call SetState(m_State)
End Sub

Public Sub Init(ByRef picParent As VB.PictureBox, _
                Optional ByVal lngLeft As Long = -1000000, _
                Optional ByVal lngTop As Long = -1000000, _
                Optional ByVal lngWidth As Long = -1, _
                Optional ByVal lngHeight As Long = -1, _
                Optional ByVal enStyle As enumButtonStyles = [Style SC-0], _
                Optional ByVal bVisible As Boolean = True, _
                Optional ByVal bEnable As Boolean = True, _
                Optional ByVal lngBackColor As Long = vbBlack, _
                Optional ByVal lngForeColor As Long = vbWhite, _
                Optional ByVal strCaption As String = vbNullString, _
                Optional ByVal strFontName As String = "MS Sans Serif", _
                Optional ByVal bFontBold As Boolean = False, _
                Optional ByVal bFontItalic As Boolean = False, _
                Optional ByVal lngFontSize As Long = 8)
    m_BlockDraw = True
    Set hParent = picParent
    hParent.Visible = bVisible
    hParent.ScaleMode = vbPixels
    hParent.AutoRedraw = True
    hParent.Appearance = 0 'flat
    hParent.BorderStyle = 0 'none
    Call Cls
    hParent.Enabled = bEnable
    If (lngLeft > -1000000) Then hParent.Left = lngLeft
    If (lngTop > -1000000) Then hParent.Top = lngTop
    If (lngWidth > -1) Then hParent.Width = lngWidth
    If (lngHeight > -1) Then hParent.Height = lngHeight
    m_Style = enStyle
    hParent.BackColor = lngBackColor
    hParent.ForeColor = lngForeColor
    m_Caption = strCaption
    hParent.FontName = strFontName
    hParent.FontBold = bFontBold
    hParent.FontItalic = bFontItalic
    If (lngFontSize < 0) Then lngFontSize = 1
    hParent.FontSize = lngFontSize
    m_State = IIf(hParent.Enabled, BFS_NORMAL_UP, BFS_DISABLED)
    m_BlockDraw = False
    Call SetState(m_State)
End Sub


Public Sub Cls()
    hParent.Cls
End Sub

Public Property Get Width() As Long
    Width = hParent.ScaleWidth
End Property
Public Property Get Height() As Long
    Height = hParent.ScaleHeight
End Property
Public Property Get Left() As Long
    Left = hParent.Left
End Property
Public Property Get Top() As Long
    Top = hParent.Top
End Property

Public Property Get State() As Long
    State = m_State
End Property

Public Property Get hDC() As Long
    hDC = hParent.hDC
End Property

Public Property Get hWnd() As Long
    hWnd = hParent.hWnd
End Property

Public Property Get Caption() As String
    Caption = m_Caption
End Property
Public Property Let Caption(ByVal strNew As String)
    If (StrComp(strNew, m_Caption, vbBinaryCompare) = 0) Then Exit Property
    m_Caption = strNew
    Call SetState(m_State)
End Property

Public Property Get BackColor() As Long
    BackColor = hParent.BackColor
End Property
Public Property Let BackColor(ByVal lngNew As Long)
    If (lngNew = hParent.BackColor) Then Exit Property
    hParent.BackColor = lngNew
    Call SetState(m_State)
End Property

Public Property Get ForeColor() As Long
    ForeColor = hParent.ForeColor
End Property
Public Property Let ForeColor(ByVal lngNew As Long)
    If (lngNew = hParent.ForeColor) Then Exit Property
    hParent.ForeColor = lngNew
    Call SetState(m_State)
End Property

Public Property Get BlockDraw() As Boolean
    BlockDraw = m_BlockDraw
End Property
Public Property Let BlockDraw(ByVal bNew As Boolean)
    If (bNew = m_BlockDraw) Then Exit Property
    m_BlockDraw = bNew
End Property

Public Property Get Enabled() As Boolean
    Enabled = hParent.Enabled
End Property
Public Property Let Enabled(ByVal bNew As Boolean)
    If (bNew = hParent.Enabled) Then Exit Property
    hParent.Enabled = bNew
    Call SetState(IIf(bNew, BFS_NORMAL_UP, BFS_DISABLED))
End Property

Public Property Get Visible() As Boolean
    Visible = hParent.Visible
End Property
Public Property Let Visible(ByVal bNew As Boolean)
    If (bNew = hParent.Visible) Then Exit Property
    hParent.Visible = bNew
    If bNew Then Call SetState(m_State)
End Property

Public Property Get Font() As StdFont
    Set Font = hParent.Font
End Property
Public Property Set Font(ByVal fntNew As StdFont)
    Set hParent.Font = NewFont
    Call SetState(m_State)
End Property

Public Property Get Style() As enumButtonStyles
    Style = m_Style
End Property
Public Property Let Style(ByVal styNew As enumButtonStyles)
    If (styNew = m_Style) Then Exit Property
    m_Style = styNew
    Call SetState(m_State)
End Property

Public Property Get Parent() As PictureBox
    Set Parent = hParent
End Property
Public Property Set Parent(ByVal picNew As PictureBox)
    Set hParent = picNew
End Property






Private Sub hParent_GotFocus()
    m_HasFocus = True
    If m_Pressed Then
        Call SetState(BFS_FOCUS_DOWN)
    Else
        Call SetState(BFS_FOCUS_UP)
    End If
End Sub
Private Sub hParent_LostFocus()
    m_HasFocus = False
    If m_Pressed Then
        Call SetState(BFS_NORMAL_DOWN)
    Else
        Call SetState(BFS_NORMAL_UP)
    End If
End Sub
Private Sub hParent_Click()
    If m_LeftClicked Then RaiseEvent Click 'only left click triggers "click" event
    m_LeftClicked = False
End Sub
Private Sub hParent_DblClick()
    RaiseEvent DblClick
End Sub
Private Sub hParent_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub
Private Sub hParent_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub
Private Sub hParent_KeyPress(KeyAscii As Integer)
    If (KeyAscii = 13) Then RaiseEvent Click 'enter
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub hParent_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_ClickedOver = True
    m_Pressed = True
    If (Button = 1) Then
        m_LeftClicked = True
        Call SetState(BFS_FOCUS_DOWN)
    End If
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub
Private Sub hParent_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_Pressed = False
    If m_HasFocus Then
        Call SetState(BFS_FOCUS_UP)
    Else
        Call SetState(BFS_NORMAL_UP)
    End If
    If m_ClickedOver Then
        RaiseEvent MouseUp(Button, Shift, X, Y)
        If (Button = 1) Then
            RaiseEvent LeftClick(Shift)
        ElseIf (Button = 2) Then
            RaiseEvent RightClick(Shift)
        ElseIf (Button = 4) Then
            RaiseEvent MiddleClick(Shift)
        End If
    Else
        RaiseEvent MissClick
    End If
End Sub
Private Sub hParent_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = 1 Or Button = 2 Or Button = 4 Then
        '//Check if we have dragged off the button
        If (X > hParent.ScaleWidth) Then
            If m_ClickedOver And (Button = 1) Then
                Call SetState(BFS_FOCUS_UP)
            End If
            m_ClickedOver = False
        ElseIf (X < 0) Then
            If m_ClickedOver And (Button = 1) Then
                Call SetState(BFS_FOCUS_UP)
            End If
            m_ClickedOver = False
        ElseIf (Y > hParent.ScaleHeight) Then
            If m_ClickedOver And (Button = 1) Then
                Call SetState(BFS_FOCUS_UP)
            End If
            m_ClickedOver = False
        ElseIf (Y < 0) Then
            If m_ClickedOver And (Button = 1) Then
                Call SetState(BFS_FOCUS_UP)
            End If
            m_ClickedOver = False
        Else
            If (Not m_ClickedOver) And (Button = 1) Then
                Call SetState(BFS_FOCUS_DOWN)
            End If
            m_ClickedOver = True
        End If
    End If
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub


Private Sub SetState(ByVal State As enumButtonFaceState)
    m_State = State
    If m_BlockDraw Then Exit Sub
    If (hParent.Visible = False) Then Exit Sub
    RaiseEvent Draw
End Sub




