VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsScrollBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private WithEvents hParent   As VB.PictureBox
Attribute hParent.VB_VarHelpID = -1


Private m_ScrollBarLeft      As Single
Private m_ScrollBarTop       As Single
Private m_ScrollBarWidth     As Single
Private m_ScrollBarHeight    As Single

Private m_Enabled            As Boolean
Private m_Visible            As Boolean
Private m_TabCount           As Long '0 to tabcount possible scrolls
Private m_TabPos             As Long 'position in the tabcount
Private m_BarRatio           As Long 'small number and the bar gets bigger fast



Private Button1              As RECT
Private Button2              As RECT
Private Bar                  As RECT
Private m_BarVisible         As Boolean
Private m_BarGapAvalible     As Single
Private m_BarHeight          As Single
Private m_ScrollGap          As Single
Private BarArea              As RECT

'bar key pressing
Private m_BarPressed         As Boolean
Private m_BarHoldOffset      As Single

Public Event Scroll()

Friend Sub GetUp(ByRef R As RECT)
    R = Button1
End Sub
Friend Sub GetDown(ByRef R As RECT)
    R = Button2
End Sub
Friend Sub GetBar(ByRef R As RECT)
    R = Bar
End Sub

Public Property Get Parent() As PictureBox:   Set Parent = hParent:         End Property
Public Property Get Left() As Single:         Left = m_ScrollBarLeft:       End Property
Public Property Get Top() As Single:          Top = m_ScrollBarTop:         End Property
Public Property Get Width() As Single:        Width = m_ScrollBarWidth:     End Property
Public Property Get Height() As Single:       Height = m_ScrollBarHeight:   End Property
Public Property Get Enabled() As Boolean:     Enabled = m_Enabled:          End Property
Public Property Get Visible() As Boolean:     Visible = m_Visible:          End Property
Public Property Get ScrollCount() As Long:    ScrollCount = m_TabCount:     End Property
Public Property Get Value() As Long:          Value = m_TabPos:             End Property
Public Property Get BarRatio() As Long:       BarRatio = m_BarRatio:        End Property
Public Property Get BarVisible() As Boolean:  BarVisible = m_BarVisible:    End Property
Public Property Get hDC() As Long:            hDC = hParent.hDC:            End Property
Public Property Get hWnd() As Long:           hWnd = hParent.hWnd:          End Property
Public Property Get Style() As Byte:          Style = 0:                    End Property

Public Property Set Parent(ByRef vNewParent As PictureBox):  Set hParent = vNewParent:     End Property
Public Property Let Left(ByVal vNewValue As Single)
    m_ScrollBarLeft = vNewValue
    Call CalcEverything
End Property
Public Property Let Top(ByVal vNewValue As Single)
    m_ScrollBarTop = vNewValue
    Call CalcEverything
End Property
Public Property Let Width(ByVal vNewValue As Single)
    m_ScrollBarWidth = vNewValue
    Call CalcEverything
End Property
Public Property Let Height(ByVal vNewValue As Single)
    m_ScrollBarHeight = vNewValue
    Call CalcEverything
End Property
Public Property Let Enabled(ByVal vNewValue As Boolean)
    m_Enabled = vNewValue
End Property
Public Property Let Visible(ByVal vNewValue As Boolean)
    m_Visible = vNewValue
End Property
Public Property Let ScrollCount(ByVal vNewValue As Long)
    If vNewValue < 0 Then vNewValue = 0
    m_TabCount = vNewValue
    If m_TabPos > m_TabCount Then m_TabPos = m_TabCount
    Call CalcEverything
    RaiseEvent Scroll
End Property
Public Property Let Value(ByVal vNewValue As Long)
    If (vNewValue < 0) Then Exit Property
    m_TabPos = vNewValue
    If m_TabPos > m_TabCount Then m_TabPos = m_TabCount
    Call CalcEverything
    RaiseEvent Scroll
End Property
Public Property Let BarRatio(ByVal vNewValue As Long)
    m_BarRatio = vNewValue
    If m_BarRatio < 1 Then m_BarRatio = 1
    If m_BarRatio > 20 Then m_BarRatio = 20
    Call CalcEverything
End Property

Public Sub Refresh()
    RaiseEvent Scroll
End Sub

Private Sub CalcEverything()
    'defalt button sizes are 16 by 16
    If (Me.Height <= (16 * 3)) Then
        'no room for the middle scrolling bar
        m_BarVisible = False
        If (Me.Height < (16 * 2)) Then
            'both buttons need to be sqwished
            Call FoldButtonSize(Button1, True)
            Call FoldButtonSize(Button2, False)
        Else
            'draw both buttons only
            Call DefaltButtonSize(Button1, True)
            Call DefaltButtonSize(Button2, False)
        End If
    Else
        m_BarVisible = True
        'can draw both buttons + scroll bar
        Call DefaltButtonSize(Button1, True)
        Call DefaltButtonSize(Button2, False)
        Call MakeBar
    End If
End Sub



Private Sub MakeBar()
    'work out how many pixels avalible for the scrolling bar
    m_BarGapAvalible = (Me.Height - (16 * 2))
    'work out how much if this should be given to the bar based on the scrolling count
    If (m_TabCount * m_BarRatio) > 0 Then
        m_BarHeight = (m_BarGapAvalible - (m_TabCount * m_BarRatio))
    Else
        m_BarHeight = m_BarGapAvalible - 1
    End If
    If m_BarHeight < 8 Then m_BarHeight = 8
    
    m_ScrollGap = (m_BarGapAvalible - m_BarHeight)
    
    'position in lngScrollGap is (lngScrollGap vs (m_Count and m_Pos))
    '(100 / Base) * Current = Percent
    Dim lngTop As Single
    lngTop = ((1000 / (m_TabCount + 1)) * m_TabPos) 'percent of the main scroll values
    lngTop = ((m_ScrollGap / 1000) * lngTop) 'converted to the percent of the avalible gap
    
    BarArea.Left = Me.Left
    BarArea.Top = Button1.Bottom
    BarArea.Right = Me.Left + Me.Width
    BarArea.Bottom = Button2.Top
    
    
    With Bar
        .Left = Me.Left
        .Top = Me.Top + 16 + lngTop '+ 1
        .Right = .Left + Me.Width
        .Bottom = .Top + m_BarHeight
    End With
End Sub

Private Sub FoldButtonSize(ByRef bButton As RECT, ByVal bTop As Boolean)
    'button needs to be half the size of the main scroll bar
    With bButton
        .Left = m_ScrollBarLeft
        If bTop Then
            .Top = m_ScrollBarTop
        Else
            .Top = m_ScrollBarTop + (Me.Height / 2)
        End If
        .Right = .Left + Me.Width
        .Bottom = .Top + (Me.Height / 2) 'height
    End With
End Sub
Private Sub DefaltButtonSize(ByRef bButton As RECT, ByVal bTop As Boolean)
    'sets the defalt size of top/bottom button based on height
    With bButton
        .Left = m_ScrollBarLeft
        If bTop Then
            .Top = m_ScrollBarTop
        Else
            .Top = m_ScrollBarTop + (Me.Height - 16)
        End If
        .Right = .Left + Me.Width 'width
        .Bottom = .Top + 16 'height
    End With
End Sub




Private Function InRangeWithMe(x As Single, y As Single) As Boolean
    If x < m_ScrollBarLeft Then Exit Function
    If x > m_ScrollBarLeft + m_ScrollBarWidth Then Exit Function
    If y < m_ScrollBarTop Then Exit Function
    If y > m_ScrollBarTop + m_ScrollBarHeight Then Exit Function
    InRangeWithMe = True
End Function
Private Function InRangeWithRect(ByRef bRect As RECT, x As Single, y As Single) As Boolean
    If x < bRect.Left Then Exit Function
    If x > bRect.Right Then Exit Function
    If y < bRect.Top Then Exit Function
    If y > bRect.Bottom Then Exit Function
    InRangeWithRect = True
End Function



Private Sub Class_Initialize()
    m_BarRatio = 1
    m_Enabled = True
End Sub


Private Sub hParent_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Not Button = 1 Then Exit Sub
    If InRangeWithMe(x, y) = False Then Exit Sub
    If InRangeWithRect(Button1, x, y) Then
        'scroll up 1
        Me.Value = Me.Value - 1
    ElseIf InRangeWithRect(Bar, x, y) And m_BarVisible Then
        m_BarPressed = True
        m_BarHoldOffset = (y - Bar.Top)
    ElseIf InRangeWithRect(Button2, x, y) Then
        'scroll down 1
        Me.Value = Me.Value + 1
    Else
        'the back ground was clicked, auto scroll to that position
        m_BarPressed = True
        If y < Bar.Top Then 'up
            m_BarPressY = Bar.Top
        ElseIf y > Bar.Bottom Then 'down
            m_BarPressY = Bar.Bottom
        End If
        Call hParent_MouseMove(Button, Shift, x, y)
        m_BarPressed = False
    End If
End Sub

Private Sub hParent_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If (Not Button = 1) Then Exit Sub
    If Not m_BarPressed Then Exit Sub
    
    
    Dim lngY        As Single
    
    'Get/move are new mouse location based on bararea
    lngY = y - m_BarHoldOffset
    If lngY < BarArea.Top Then lngY = BarArea.Top
    If lngY > BarArea.Bottom Then lngY = BarArea.Bottom
    
    'move the bar
    Bar.Top = lngY
    Bar.Bottom = Bar.Top + m_BarHeight
    
    'calculate the new scroll position
    If Bar.Top <= BarArea.Top Then
        Me.Value = 0
    ElseIf Bar.Bottom >= BarArea.Bottom Then
        Me.Value = m_TabCount
    Else
        '//CALCULATE THE NEW POSITION HERE (reverse the makebar() maths)
        '//Get the % of the Bar.top location in BarArea.top to BarArea.bottom
        '//Convert that % to the % position in the m_TabCount to m_TabPos
        '//set m_TabPos (Me.Value) tot hat position
        
        'Get the bars position percent
        lngTop = ((1000 / m_ScrollGap) * (Bar.Top - BarArea.Top))
        'get the current main position from the % given
        lngTop = Fix(((m_TabCount + 1) / 1000) * lngTop)
        'set the value
        Me.Value = lngTop
    End If
End Sub

Private Sub hParent_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    m_BarPressed = False
End Sub


