Attribute VB_Name = "modBuf"
Private m_Buf(1023)         As Byte
Private m_BufPos            As Long
Private m_Header(3)         As Byte
Private m_Addr              As sockaddr_in
Public Enum PacketHeaders
    BNCS_HEADER = 4
    BNLS_HEADER = 3
End Enum

Public Sub iClear()
    m_BufPos = 0
End Sub
Public Sub iBYTE(ByRef bValue As Byte)
    m_Buf(m_BufPos) = bValue
    m_BufPos = m_BufPos + 1
End Sub
Public Sub iWORD(ByRef intValue As Integer)
    Call CopyMemory(m_Buf(m_BufPos), intValue, 2)
    m_BufPos = m_BufPos + 2
End Sub
Public Sub iDWORD(ByRef lngValue As Long)
    Call CopyMemory(m_Buf(m_BufPos), lngValue, 4)
    m_BufPos = m_BufPos + 4
End Sub
Public Sub iFILETIME(ByRef udtFT As FILETIMESTRUT)
    Call CopyMemory(m_Buf(m_BufPos), udtFT, 8)
    m_BufPos = m_BufPos + 8
End Sub
Public Sub iSTRING(ByRef strValue As String)
    Dim intLen          As Integer
    intLen = Len(strValue)
    If (intLen = 0) Then Exit Sub
    Call CopyMemory(m_Buf(m_BufPos), ByVal strValue, intLen)
    m_BufPos = m_BufPos + intLen
End Sub
Public Sub iNTSTRING(ByRef strValue As String)
    Dim intLen          As Integer
    intLen = Len(strValue)
    If (Not intLen = 0) Then
        Call CopyMemory(m_Buf(m_BufPos), ByVal strValue, intLen)
        m_BufPos = m_BufPos + intLen
    End If
    Call iBYTE(0)
End Sub
Public Sub iHEADER(ByVal PacketID As Byte, Optional ByVal Header As PacketHeaders = BNCS_HEADER)
    Dim intLen      As Integer
    intLen = CInt(Header)
    If (Header = BNCS_HEADER) Then
        m_Header(0) = &HFF
        m_Header(1) = PacketID
        Call CopyMemory(m_Header(2), CInt(m_BufPos + 4), 2)
    ElseIf (Header = BNLS_HEADER) Then
        Call CopyMemory(m_Header(0), CInt(m_BufPos + 3), 2)
        m_Header(2) = PacketID
    Else
        Exit Sub
    End If
    Call CopyMemory(m_Buf(intLen), m_Buf(0), m_BufPos)
    Call CopyMemory(m_Buf(0), m_Header(0), intLen)
    m_BufPos = m_BufPos + intLen
End Sub
Public Sub iPacket(ByRef lngHandle As Long)
    If (m_BufPos = 0) Then Exit Sub 'empty buffer
    If (send(lngHandle, m_Buf(0), m_BufPos, 0&) = -1) Then
        Debug.Print "[TCP_SOCKET ERROR] Unable to send data"
    End If
    Call iClear
End Sub
Public Sub iUDP(ByRef lngHandle As Long, ByRef lngAddr As Long, ByRef intPort As Integer)
    If (m_BufPos = 0) Then Exit Sub 'empty buffer
    m_Addr.sin_addr = lngAddr
    m_Addr.sin_port = intPort
    m_Addr.sin_family = 2
    If (sendto(lngHandle, m_Buf(0), m_BufPos, 0&, m_Addr, 16&) = -1) Then
        Debug.Print "[UDP_SOCKET ERROR] Unable to send data"
    End If
End Sub

